////////////////////////////////////////////////////////////////////////////////
//
//
//   Author       : Bogdan Popescu
//   Organization : University of Cincinnati
//   Program      : gocolors2
//   Version      : 2.013
//   Date         : Dec 10, 2013
//   Tested       : g++ 4.6.3 x64 (Ubuntu 12.04 LTS x64)
//                       
//                    
//                  
//
////////////////////////////////////////////////////////////////////////////////
//
//    MASSCLEAN (MASSive CLuster Evolution and ANalysis Package)
//    Copyright (C) 2007-2013 BOGDAN POPESCU and MARGARET HANSON
//
//    gocolors2.cc is part of MASSCLEAN.
//
//    MASSCLEAN is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation.
//
//    MASSCLEAN is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with MASSCLEAN; if not, write to the Free Software
//    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//    or go to : http://www.gnu.org/licenses/gpl.html
//
////////////////////////////////////////////////////////////////////////////////


#include <cstdlib>
#include <ctime>
#include <iostream>
#include <fstream>
#include <stdio.h>
#include <math.h>
#include <ctype.h> 
#include <iomanip> 

#define NOCOLUMNS 1
#define PI 3.14159265

using namespace std;


int alllines(char *name)
{
//////////////////////
////
//// 
////

  int NOLINES;

  char oneline[400];
  NOLINES=0;

  ifstream data0;

  data0.open(name);

  if (data0.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (!data0.eof())
  {
     if (!isdigit(data0.peek()) || !isspace(data0.peek()))
	{
	    NOLINES=NOLINES+1;

            data0.getline(oneline,400,'\n');

	    if(data0.eof()) break;
	}

     if (isdigit(data0.peek()) || isspace(data0.peek()))
       {
            NOLINES=NOLINES+1;

            data0.getline(oneline,400,'\n');

            if(data0.eof()) break;
        }

   if(data0.eof()) break;
   }

  data0.close();

  return NOLINES;

}


int alldatalines(char *name, int NOLINES)
{
//////////////////////
////
//// 
////

  int i,k;

  int NODATALINES;

  double read_column;

  NODATALINES=0;

  ifstream data1;

  data1.open(name);

  if (data1.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

for (k=0;k<(NOLINES);k++)
 {
   if (isdigit(data1.peek()) || isspace(data1.peek()))
       {
       for (i=0;i<(NOCOLUMNS);i++)  
            {                      
            data1 >> read_column ;
            
            }
        NODATALINES=NODATALINES+1;

        if(data1.eof()) break;
        }

   if (!isdigit(data1.peek()) || !isspace(data1.peek()))
	  {data1.ignore(400,'\n');data1.peek(); }

 if(data1.eof()) break;
 }

  data1.close();

return NODATALINES;

}


int alldatacolumns(char *name)
{
//////////////////////
////
//// 
////

  int NOCOL;

  double col;

  NOCOL=0;

  ifstream data3;

  data3.open(name);

  if (data3.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (data3.peek()=='#') {data3.ignore(400,'\n'); }

  while (1)
  {
  data3 >> col ;

  NOCOL=NOCOL+1;

  if(data3.peek()=='\n') break;

  if(data3.eof()) break;
  }

  data3.close();

 return NOCOL;

}




int datalinescolumn(char *name, int i)

{
 if (i==1) return alldatalines(name,alllines(name));
 if (i==2) return alldatacolumns(name);
}



///////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
///////////
///////////  MAIN PROGRAM
///////////
//////////////////////////////////////////////////////////////////////////////////



int main()
{

  cout << "\n";


  cout <<"MASSCLEAN 2.013 (MASSive CLuster Evolution and ANalysis Package)"<<"\n";

  cout <<"Copyright (C) 2007-2013 BOGDAN POPESCU and MARGARET HANSON,"<<"\n";

  cout <<"under GNU General Public License. For details see 'COPYING'."<<"\n";

  cout <<"The program 'goCOLORS2' is part of MASSCLEAN 2.013 BB (Brave Bunny)."<<"\n";

  cout << "\n";
  cout <<"http://www.physics.uc.edu/~popescu/massclean/"<< '\n';

  cout << "\n";


  cout <<"Popescu & Hanson 2009, AJ, 138, 1724"<< '\n';
  cout <<"Popescu & Hanson 2010, ApJL, 713, L21"<< '\n';
  cout <<"Popescu & Hanson 2010, ApJ, 724, 296"<< '\n';
  cout <<"Popescu, Hanson & Elmegreen 2012, ApJ, 751, 122"<< '\n';
  cout <<"Popescu & Hanson 2014, ApJ, 780, 27"<< '\n';


  cout << "\n";
  cout << "\n";


  /// prototypes
  int alllines(char*);
  int alldatalines(char*,int);
  int alldatacolumns(char*);
  int datalinescolumn(char*,int);

  srand((unsigned)time(0));



  double mass, dd;
  int VERBOSE;
  double sari;
  int ccm_on_off;
  double A_U,A_B,A_V,A_R,A_I,A_J,A_H,A_K;
  int n;
  double A_J2mass,A_H2mass,A_K2mass;
  double A1,A2,A3,A4,A5;



////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////


int savemass2;

savemass2=1;
//savemass2=100;

double sari299,m399,m299,mmax99,massread99;





//// nou mmaxcluster

int savemass;

savemass=1;
//savemass=100;

//////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////

double sari2,m3,m2,mmax,massread;

if (savemass==1)
{


chdir("data");

  ifstream data4;

  data4.open("n_distribution.out");

  if (data4.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }


/*
int final=datalinescolumn("n_distribution.out",1);

double mmaxcluster,mmaxcluster2;
double mmax3,mmax2;
double mmax3read,mmax2read;

int kl;

//cout << final <<'\n';

while (data4.peek()=='#') { data4.ignore(300,'\n');}

for (kl=1;kl<=final;kl++)
{
data4 >> mmaxcluster2;
data4.ignore(300,'\n');
//cout <<"cucu "<< mmaxcluster2 <<'\n';
//mmaxcluster=mmaxcluster2;

if (kl==(final-1)) {mmax2read=mmaxcluster2;}
if (kl==(final-2)) {mmax3read=mmaxcluster2;}

}

mmaxcluster=mmaxcluster2;
mmax2=mmax2read;
mmax3=mmax3read;

*/


int NBIN;
NBIN=datalinescolumn("n_distribution.out",1);
//cout <<NBIN<<'\n';

//double sari2,m3,m2,mmax,massread;

int i;

while (data4.peek()=='#') { data4.ignore(300,'\n');}

mmax=0.;

for (i=1;i<=NBIN;i++)
{

//data4.ignore(300,'\n');

//}

data4 >> massread;
data4.ignore(300,'\n');

//if (i=1) {mmax=massread;}

if (massread>=mmax) {mmax=massread;}

//if (i==NBIN) {cout<<setw(6)<< mmax <<'\n';}


//data4 >> m2;
//data4.ignore(300,'\n');

//data4 >> mmax;
//data4.ignore(300,'\n');

//cout << m3 <<'\n';
//cout << m2 <<'\n';
//cout << mmax <<'\n';
}

data4.close();

//////////////////////////////////////
// m2

  ifstream data44;

  data44.open("n_distribution.out");

  if (data44.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }


while (data44.peek()=='#') { data44.ignore(300,'\n');}

m2=0.;

for (i=1;i<=NBIN;i++)
{

//data4.ignore(300,'\n');

//}

data44 >> massread;
data44.ignore(300,'\n');

//if (i=1) {mmax=massread;}

if ((massread>=m2) && (massread<mmax) ) {m2=massread;}

//if (i==NBIN) {cout<<setw(6)<< m2 <<'\n';}


//data4 >> m2;
//data4.ignore(300,'\n');

//data4 >> mmax;
//data4.ignore(300,'\n');

//cout << m3 <<'\n';
//cout << m2 <<'\n';
//cout << mmax <<'\n';
}

data44.close();


//////////////////////++++++++++++++++++++++


//////////////////////////////////////
// m3

  ifstream data444;

  data444.open("n_distribution.out");

  if (data444.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }


while (data444.peek()=='#') { data444.ignore(300,'\n');}

m3=0.;

for (i=1;i<=NBIN;i++)
{

//data4.ignore(300,'\n');

//}

data444 >> massread;
data444.ignore(300,'\n');

//if (i=1) {mmax=massread;}

if ((massread>=m3) && (massread<m2) ) {m3=massread;}

//if (i==NBIN) {cout<<setw(6)<< m3 <<'\n';}


//data4 >> m2;
//data4.ignore(300,'\n');

//data4 >> mmax;
//data4.ignore(300,'\n');

//cout << m3 <<'\n';
//cout << m2 <<'\n';
//cout << mmax <<'\n';
}

data444.close();


//////////////////////++++++++++++++++++++++





//////////////////

chdir("..");

/////////////////// nou mmaxcluster

} /// savemass


chdir("ini.files");




ifstream setsfile;
setsfile.open("sets.ini");

  if (setsfile.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

while (setsfile.peek()=='#') { setsfile.ignore(300,'\n');}

int ss;
setsfile >> ss; setsfile.ignore(300,'\n');
setsfile.close();






ifstream colorinifile;
colorinifile.open("colors.ini");

  if (colorinifile.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (colorinifile.peek()=='#') { colorinifile.ignore(300,'\n');}
  
  
int COLORINI;
  
  colorinifile >> COLORINI;
  colorinifile.ignore(300,'\n');
  
  colorinifile.close();
  



ifstream clusterfile;
clusterfile.open("cluster.ini");

  if (clusterfile.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (clusterfile.peek()=='#') { clusterfile.ignore(300,'\n');}

  clusterfile >> VERBOSE; clusterfile.ignore(300,'\n');
  clusterfile >> mass; clusterfile.ignore(300,'\n');
  clusterfile >> dd; clusterfile.ignore(300,'\n');

clusterfile >> sari; clusterfile.ignore(300,'\n');
clusterfile >> sari; clusterfile.ignore(300,'\n');
clusterfile >> sari; clusterfile.ignore(300,'\n');
clusterfile >> sari; clusterfile.ignore(300,'\n');
clusterfile >> sari; clusterfile.ignore(300,'\n');

clusterfile >> ccm_on_off; clusterfile.ignore(300,'\n');

  if (ccm_on_off==0)
  {
  clusterfile >> sari; clusterfile.ignore(300,'\n');
//  clusterfile >> sari; clusterfile.ignore(300,'\n');
  clusterfile >> A_U; clusterfile.ignore(300,'\n');
  clusterfile >> A_B; clusterfile.ignore(300,'\n');
  clusterfile >> A_V; clusterfile.ignore(300,'\n');
  clusterfile >> A_R; clusterfile.ignore(300,'\n');
  clusterfile >> A_I; clusterfile.ignore(300,'\n');
  clusterfile >> A_J; clusterfile.ignore(300,'\n');
  clusterfile >> A_H; clusterfile.ignore(300,'\n');
  clusterfile >> A_K; clusterfile.ignore(300,'\n');

  clusterfile >> A1; clusterfile.ignore(300,'\n');
  clusterfile >> A1; clusterfile.ignore(300,'\n');
  clusterfile >> A3; clusterfile.ignore(300,'\n');
  clusterfile >> A4; clusterfile.ignore(300,'\n');
  clusterfile >> A5; clusterfile.ignore(300,'\n');


  }

 clusterfile.ignore(300,'\n');

 clusterfile.close();


 if (VERBOSE==1)
 {
 cout << "Reading file cluster.ini...";

 cout << "...done !"<<'\n';
 }

chdir("..");

///// end cluster.ini


/// extinction

if (ccm_on_off==1)
{
chdir("data"); 

if (VERBOSE==1)
{
cout << "Reading file ccm.filters...";
}

ifstream filterfile1;
filterfile1.open("ccm.filters");

  if (filterfile1.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (filterfile1.peek()=='#') { filterfile1.ignore(300,'\n');}

filterfile1 >> A_U; filterfile1.ignore(300,'\n');
filterfile1 >> A_B; filterfile1.ignore(300,'\n');
filterfile1 >> A_V; filterfile1.ignore(300,'\n');
filterfile1 >> A_R; filterfile1.ignore(300,'\n');
filterfile1 >> A_I; filterfile1.ignore(300,'\n');
filterfile1 >> A_J; filterfile1.ignore(300,'\n');
filterfile1 >> A_H; filterfile1.ignore(300,'\n');
filterfile1 >> A_K; filterfile1.ignore(300,'\n');

filterfile1 >> A1; filterfile1.ignore(300,'\n');
filterfile1 >> A2; filterfile1.ignore(300,'\n');
filterfile1 >> A3; filterfile1.ignore(300,'\n');
filterfile1 >> A4; filterfile1.ignore(300,'\n');
filterfile1 >> A5; filterfile1.ignore(300,'\n');


filterfile1.ignore(300,'\n');

filterfile1.close();

if (VERBOSE==1)
{
cout << "...done !"<<'\n';
cout <<'\n';
}

chdir(".."); 


}
/// extinction end



// distance modulus

  double apparent;

  apparent=5.*log10(dd/10.);

 

/// output
chdir("data");
chdir("colors");

//if (ss==1) 
//{
//ofstream colorfile("intcolors");
//}

//if (ss>1) 
//{
ofstream colorfile("intcolors.01");
ofstream colorfile0("intcolors");
ofstream colorfile2("intcolors.02");
/////////////////////////ofstream colorfile3("intcolors.03"); //**************************************
//}




if (COLORINI==1)
{

  colorfile <<"##  "<< '\n';
  colorfile <<"##  MASSCLEAN 2.013 Brave Bunny"<< '\n';
  colorfile <<"##  B.Popescu and M.M.Hanson, 2007-2013 "<< '\n';
  colorfile <<"##  http://www.physics.uc.edu/~popescu/massclean/"<< '\n';

  colorfile <<"##  "<< '\n';

  colorfile <<"##  Popescu & Hanson 2009, AJ, 138, 1724"<< '\n';
  colorfile <<"##  Popescu & Hanson 2010, ApJL, 713, L21"<< '\n';
  colorfile <<"##  Popescu & Hanson 2010, ApJ, 724, 296"<< '\n';
  colorfile <<"##  Popescu, Hanson & Elmegreen 2012, ApJ, 751, 122"<< '\n';
  colorfile <<"##  Popescu & Hanson 2014, ApJ, 780, 27"<< '\n';

  colorfile <<"##  "<< '\n';


colorfile << "##  log(age)        U             B             V             R             I             J             H             K            U-B          B-V            V-K       "<<'\n';
colorfile << "##     1            2             3             4             5             6             7             8             9             10           11             12       "<<'\n';
}
chdir("..");
chdir("..");
///


if (COLORINI==1)
{

  colorfile2 <<"##  "<< '\n';
  colorfile2 <<"##  MASSCLEAN 2.013 Brave Bunny"<< '\n';
  colorfile2 <<"##  B.Popescu and M.M.Hanson, 2007-2013 "<< '\n';
  colorfile2 <<"##  http://www.physics.uc.edu/~popescu/massclean/"<< '\n';

  colorfile2 <<"##  "<< '\n';

  colorfile2 <<"##  Popescu & Hanson 2009, AJ, 138, 1724"<< '\n';
  colorfile2 <<"##  Popescu & Hanson 2010, ApJL, 713, L21"<< '\n';
  colorfile2 <<"##  Popescu & Hanson 2010, ApJ, 724, 296"<< '\n';
  colorfile2 <<"##  Popescu, Hanson & Elmegreen 2012, ApJ, 751, 122"<< '\n';
  colorfile2 <<"##  Popescu & Hanson 2014, ApJ, 780, 27"<< '\n';

  colorfile2 <<"##  "<< '\n';


colorfile2 << "##  log(age)        Z             Y             J             H             Ks                    "<<'\n';
colorfile2 << "##     1            2             3             4             5             6        "<<'\n';
}




///////////////////////////////////////
//////////////////////////////////////

///////////////////////////////////
/// citit indextrek

char sicedaca[20];
char fileplot[20];

chdir("data"); 


int NOFILESOUT;
NOFILESOUT=alllines("indextrek")-7 ;

//cout << NOFILESOUT<<'\n';

  ifstream fileindex;
  fileindex.open("indextrek");

  if (fileindex.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (fileindex.peek()=='#') { fileindex.ignore(300,'\n');}

chdir(".."); 

/////////////////////////////////
///
/// "a" loop
///
/////////////////////////////////

int a;

for (a=0;a<(NOFILESOUT);a++)
{



/////////////////////////////////////////////////////
/////////////////////////////////////////////////////
/////////// ss==1
if (ss==1)
{


chdir("data"); 


  fileindex >> fileplot;
  fileindex.ignore(500,'\n');





chdir(".."); 
///  indextrek -END
//////////////////////////////////

chdir("data");
chdir("iso.trek");



////////////////////////////////////////////////
///////////////////////////////// MAX,M2,M3



if (savemass2==1)
{


//chdir("data");

  


  ifstream data499;
  data499.open(fileplot);

  if (data499.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }



int NBIN99;
NBIN99=datalinescolumn(fileplot,1);
//cout <<NBIN99<<'\n';

//double sari299,m399,m299,mmax99,massread99;

int i99;

while (data499.peek()=='#') { data499.ignore(300,'\n');}

mmax99=0.;

for (i99=1;i99<=NBIN99;i99++)
{

//data499.ignore(300,'\n');

//}

data499 >> sari299;
data499 >> massread99;
data499.ignore(300,'\n');

//if (i=1) {mmax99=massread99;}

if (massread99>=mmax99) {mmax99=massread99;}

//if (i==NBIN99) {cout<<setw(6)<< mmax99 <<'\n';}


//data499 >> m299;
//data499.ignore(300,'\n');

//data499 >> mmax99;
//data499.ignore(300,'\n');

//cout << m399 <<'\n';
//cout << m299 <<'\n';
//cout << mmax99 <<'\n';
}

data499.close();

//////////////////////////////////////
// m299

  ifstream data4994;

  data4994.open(fileplot);

  if (data4994.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }


while (data4994.peek()=='#') { data4994.ignore(300,'\n');}

m299=0.;

for (i99=1;i99<=NBIN99;i99++)
{

//data499.ignore(300,'\n');

//}

data4994 >> sari299;
data4994 >> massread99;
data4994.ignore(300,'\n');

//if (i=1) {mmax99=massread99;}

if ((massread99>=m299) && (massread99<mmax99) ) {m299=massread99;}

//if (i==NBIN99) {cout<<setw(6)<< m299 <<'\n';}


//data499 >> m299;
//data499.ignore(300,'\n');

//data499 >> mmax99;
//data499.ignore(300,'\n');

//cout << m399 <<'\n';
//cout << m299 <<'\n';
//cout << mmax99 <<'\n';
}

data4994.close();


//////////////////////++++++++++++++++++++++


//////////////////////////////////////
// m399

  ifstream data49944;

  data49944.open(fileplot);

  if (data49944.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }


while (data49944.peek()=='#') { data49944.ignore(300,'\n');}

m399=0.;

for (i99=1;i99<=NBIN99;i99++)
{

//data499.ignore(300,'\n');

//}

data49944 >> sari299;
data49944 >> massread99;
data49944.ignore(300,'\n');

//if (i=1) {mmax99=massread99;}

if ((massread99>=m399) && (massread99<m299) ) {m399=massread99;}

//if (i==NBIN99) {cout<<setw(6)<< m399 <<'\n';}


//data499 >> m299;
//data499.ignore(300,'\n');

//data499 >> mmax99;
//data499.ignore(300,'\n');

//cout << m399 <<'\n';
//cout << m299 <<'\n';
//cout << mmax99 <<'\n';
}

data49944.close();


//////////////////////++++++++++++++++++++++





//////////////////

//chdir("..");

/////////////////// nou mmax99cluster

} /// savemass2





///////////////////////////////// MAX,M2,M3
///////////////////////////////////////////////


  int NOPLOTLINES,NOPLOTCOLUMNS;

  NOPLOTLINES=datalinescolumn(fileplot,1);
 
//cout << NOPLOTLINES <<'\n';

  NOPLOTCOLUMNS=alldatacolumns(fileplot);
 
//cout << NOPLOTCOLUMNS <<'\n';


  ifstream filein;
  filein.open(fileplot);

 
 if (filein.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (filein.peek()=='#') { filein.ignore(3000,'\n');}



if (VERBOSE==1)
{
  cout << "Reading file "<< fileplot <<" ...";
}






double nonsens;
double readit, readit1, readit2, readit3, readit4, readit5, readit6, readit7;

double readit8, readit9, readit10;

double V=0.;
double B=0.;
double U=0.; 
double R=0.;
double III=0.;
double JJJ=0.;
double HHH=0.;
double KKK=0.;

//double j2mass=0.0;
//double h2mass=0.0;
//double k2mass=0.0;

//// nou
double minimax;
double mactmax;
double age;
double age00;////NOU
//// ---- nou

//  while (1)
//{

for (n=0;n<(NOPLOTLINES);n++)
       {

       {



       filein >> age00;
       if (n==0) {age=age00;}
   
       filein >> minimax;
       filein >> mactmax;
//       filein >> nonsens;
       filein >> nonsens;  //
       filein >> nonsens;  //
 
 
 filein >> readit; 
 filein >> readit3; 
 filein >> readit1; 
 filein >> readit2; 
 filein >> readit4; 
 filein >> readit5; 
 filein >> readit6; 
 filein >> readit7; 

// filein >> readit8; 
// filein >> readit9; 
// filein >> readit10; 
       
// if ((readit<16.) && (readit3<15.)  && (readit1<13.) && (readit<12.) && (readit4<11.)  && (readit5<10.) && (readit6<9.) && (readit7<9.) )
{
{U=U+pow(10.,(-(readit-A_U-apparent)/2.5));}
{B=B+pow(10.,(-(readit3-A_B-apparent)/2.5));}
{V=V+pow(10.,(-(readit1-A_V-apparent)/2.5));}
{R=R+pow(10.,(-(readit2-A_R-apparent)/2.5));}
{III=III+pow(10.,(-(readit4-A_I-apparent)/2.5));}
{JJJ=JJJ+pow(10.,(-(readit5-A_J-apparent)/2.5));}       
{HHH=HHH+pow(10.,(-(readit6-A_H-apparent)/2.5));}
{KKK=KKK+pow(10.,(-(readit7-A_K-apparent)/2.5));}

//{j2mass=j2mass+pow(10.,(-(readit8-A_J-apparent)/2.5));}       
//{h2mass=h2mass+pow(10.,(-(readit9-A_H-apparent)/2.5));}
//{k2mass=k2mass+pow(10.,(-(readit10-A_K-apparent)/2.5));}


} 

       filein.ignore(300,'\n');



       }


        if(filein.eof()) break;
	}

//cout << minimax <<'\n';

if(filein.eof()) break;
//}

colorfile0.setf(ios::fixed,ios::floatfield);


colorfile0.precision(2);

colorfile0 << setw(6);


//if (fileplot[9]!='0') {colorfile0 << fileplot[9];}

//colorfile0<<fileplot[10]<<"."<<fileplot[11]<<fileplot[12];


colorfile0 << age ;//

colorfile0.precision(8);

colorfile0 <<"  "<< setw(12) << -2.5*log10(U);

colorfile0 <<"  "<< setw(12) << -2.5*log10(B);

colorfile0 <<"  "<< setw(12) << -2.5*log10(V);

colorfile0 <<"  "<< setw(12) << -2.5*log10(R);

colorfile0 <<"  "<< setw(12) << -2.5*log10(III);

colorfile0 <<"  "<< setw(12) << -2.5*log10(JJJ);

colorfile0 <<"  "<< setw(12) << -2.5*log10(HHH);

colorfile0 <<"  "<< setw(12) << -2.5*log10(KKK);

colorfile0 <<"  "<< setw(12) << (-2.5*log10(U))-(-2.5*log10(B));

colorfile0 <<"  "<< setw(12) << (-2.5*log10(B))-(-2.5*log10(V));

colorfile0 <<"  "<< setw(12) << (-2.5*log10(V))-(-2.5*log10(KKK));

//colorfile0 <<"  "<< setw(12) << -2.5*log10(j2mass);

//colorfile0 <<"  "<< setw(12) << -2.5*log10(h2mass);

//colorfile0 <<"  "<< setw(12) << -2.5*log10(k2mass);

/// nou

//savemass=1;
//savemass2=1;

if (savemass==1)
{
colorfile0 <<"  "<< setw(12) << mmax;
colorfile0 <<"  "<< setw(12) << m2;
colorfile0 <<"  "<< setw(12) << m3;
}


if (savemass2==1)
{
colorfile0 <<"  "<< setw(12) << mmax99;
colorfile0 <<"  "<< setw(12) << m299;
colorfile0 <<"  "<< setw(12) << m399;
}


if (savemass2==1)
{
colorfile0.precision(2);
colorfile0 <<"  "<< setw(12) << mass;
}



//colorfile0 <<"  "<< setw(12) << mmax2;
//colorfile0 <<"  "<< setw(12) << mmax3;

///---nou


colorfile0 << '\n'; 


//cout << mmaxcluster<<'\n';


if (VERBOSE==0)
{
  cout <<setw(3) << a+1 <<"/"<<(int)(NOFILESOUT/ss) <<"  UBVRIJHK ... log(age/yr)=";
  
  if (fileplot[9]!='0') {cout<<fileplot[9];} 
  if (fileplot[9]=='0') {cout<<" ";} 
  
  cout<<fileplot[10]<<"."<<fileplot[11]<<fileplot[12]<<" ";
}




cout << "... done !"<< '\n';

filein.close();

chdir("..");
chdir("..");


}
///// ss==1
////////////////////////////////
////////////////////////////////






/////////////////////////////////////////////////////
/////////////////////////////////////////////////////
/////////// ss>1 ss 1
if ((ss>1) && (a<(int)(NOFILESOUT/ss)))
{


chdir("data"); 


  fileindex >> fileplot;
  fileindex.ignore(500,'\n');





chdir(".."); 
///  indextrek -END
//////////////////////////////////

chdir("data");
chdir("iso.trek");



////////////////////////////////////////////////
///////////////////////////////// MAX,M2,M3



if (savemass2==1)
{


//chdir("data");

  


  ifstream data499;
  data499.open(fileplot);

  if (data499.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }



int NBIN99;
NBIN99=datalinescolumn(fileplot,1);
//cout <<NBIN99<<'\n';

//double sari299,m399,m299,mmax99,massread99;

int i99;

while (data499.peek()=='#') { data499.ignore(300,'\n');}

mmax99=0.;

for (i99=1;i99<=NBIN99;i99++)
{

//data499.ignore(300,'\n');

//}

data499 >> sari299;
data499 >> massread99;
data499.ignore(300,'\n');

//if (i=1) {mmax99=massread99;}

if (massread99>=mmax99) {mmax99=massread99;}

//if (i==NBIN99) {cout<<setw(6)<< mmax99 <<'\n';}


//data499 >> m299;
//data499.ignore(300,'\n');

//data499 >> mmax99;
//data499.ignore(300,'\n');

//cout << m399 <<'\n';
//cout << m299 <<'\n';
//cout << mmax99 <<'\n';
}

data499.close();

//////////////////////////////////////
// m299

  ifstream data4994;

  data4994.open(fileplot);

  if (data4994.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }


while (data4994.peek()=='#') { data4994.ignore(300,'\n');}

m299=0.;

for (i99=1;i99<=NBIN99;i99++)
{

//data499.ignore(300,'\n');

//}

data4994 >> sari299;
data4994 >> massread99;
data4994.ignore(300,'\n');

//if (i=1) {mmax99=massread99;}

if ((massread99>=m299) && (massread99<mmax99) ) {m299=massread99;}

//if (i==NBIN99) {cout<<setw(6)<< m299 <<'\n';}


//data499 >> m299;
//data499.ignore(300,'\n');

//data499 >> mmax99;
//data499.ignore(300,'\n');

//cout << m399 <<'\n';
//cout << m299 <<'\n';
//cout << mmax99 <<'\n';
}

data4994.close();


//////////////////////++++++++++++++++++++++


//////////////////////////////////////
// m399

  ifstream data49944;

  data49944.open(fileplot);

  if (data49944.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }


while (data49944.peek()=='#') { data49944.ignore(300,'\n');}

m399=0.;

for (i99=1;i99<=NBIN99;i99++)
{

//data499.ignore(300,'\n');

//}

data49944 >> sari299;
data49944 >> massread99;
data49944.ignore(300,'\n');

//if (i=1) {mmax99=massread99;}

if ((massread99>=m399) && (massread99<m299) ) {m399=massread99;}

//if (i==NBIN99) {cout<<setw(6)<< m399 <<'\n';}


//data499 >> m299;
//data499.ignore(300,'\n');

//data499 >> mmax99;
//data499.ignore(300,'\n');

//cout << m399 <<'\n';
//cout << m299 <<'\n';
//cout << mmax99 <<'\n';
}

data49944.close();


//////////////////////++++++++++++++++++++++





//////////////////

//chdir("..");

/////////////////// nou mmax99cluster

} /// savemass2





///////////////////////////////// MAX,M2,M3
///////////////////////////////////////////////


  int NOPLOTLINES,NOPLOTCOLUMNS;

  NOPLOTLINES=datalinescolumn(fileplot,1);
 
//cout << NOPLOTLINES <<'\n';

  NOPLOTCOLUMNS=alldatacolumns(fileplot);
 
//cout << NOPLOTCOLUMNS <<'\n';


  ifstream filein;
  filein.open(fileplot);

 
 if (filein.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (filein.peek()=='#') { filein.ignore(3000,'\n');}



if (VERBOSE==1)
{
  cout << "Reading file "<< fileplot <<" ...";
}






double nonsens;
double readit, readit1, readit2, readit3, readit4, readit5, readit6, readit7;

double readit8, readit9, readit10;

double V=0.;
double B=0.;
double U=0.; 
double R=0.;
double III=0.;
double JJJ=0.;
double HHH=0.;
double KKK=0.;

//double j2mass=0.0;
//double h2mass=0.0;
//double k2mass=0.0;

//// nou
double minimax;
double mactmax;
double age;
double age00;////NOU
//// ---- nou

//  while (1)
//{

for (n=0;n<(NOPLOTLINES);n++)
       {

       {



       filein >> age00;
       if (n==0) {age=age00;}
   
       filein >> minimax;
       filein >> mactmax;
//       filein >> nonsens;
       filein >> nonsens;  //
       filein >> nonsens;  //
 
 
 filein >> readit; 
 filein >> readit3; 
 filein >> readit1; 
 filein >> readit2; 
 filein >> readit4; 
 filein >> readit5; 
 filein >> readit6; 
 filein >> readit7; 

// filein >> readit8; 
// filein >> readit9; 
// filein >> readit10; 
       
// if ((readit<16.) && (readit3<15.)  && (readit1<13.) && (readit<12.) && (readit4<11.)  && (readit5<10.) && (readit6<9.) && (readit7<9.) )
{
{U=U+pow(10.,(-(readit-A_U-apparent)/2.5));}
{B=B+pow(10.,(-(readit3-A_B-apparent)/2.5));}
{V=V+pow(10.,(-(readit1-A_V-apparent)/2.5));}
{R=R+pow(10.,(-(readit2-A_R-apparent)/2.5));}
{III=III+pow(10.,(-(readit4-A_I-apparent)/2.5));}
{JJJ=JJJ+pow(10.,(-(readit5-A_J-apparent)/2.5));}       
{HHH=HHH+pow(10.,(-(readit6-A_H-apparent)/2.5));}
{KKK=KKK+pow(10.,(-(readit7-A_K-apparent)/2.5));}

//{j2mass=j2mass+pow(10.,(-(readit8-A_J-apparent)/2.5));}       
//{h2mass=h2mass+pow(10.,(-(readit9-A_H-apparent)/2.5));}
//{k2mass=k2mass+pow(10.,(-(readit10-A_K-apparent)/2.5));}


} 

       filein.ignore(300,'\n');



       }


        if(filein.eof()) break;
	}

//cout << minimax <<'\n';

if(filein.eof()) break;
//}

colorfile.setf(ios::fixed,ios::floatfield);


colorfile.precision(2);

colorfile << setw(6);


//if (fileplot[9]!='0') {colorfile << fileplot[9];}

//colorfile<<fileplot[10]<<"."<<fileplot[11]<<fileplot[12];


colorfile << age ;//

colorfile.precision(8);

colorfile <<"  "<< setw(12) << -2.5*log10(U);

colorfile <<"  "<< setw(12) << -2.5*log10(B);

colorfile <<"  "<< setw(12) << -2.5*log10(V);

colorfile <<"  "<< setw(12) << -2.5*log10(R);

colorfile <<"  "<< setw(12) << -2.5*log10(III);

colorfile <<"  "<< setw(12) << -2.5*log10(JJJ);

colorfile <<"  "<< setw(12) << -2.5*log10(HHH);

colorfile <<"  "<< setw(12) << -2.5*log10(KKK);

colorfile <<"  "<< setw(12) << (-2.5*log10(U))-(-2.5*log10(B));

colorfile <<"  "<< setw(12) << (-2.5*log10(B))-(-2.5*log10(V));

colorfile <<"  "<< setw(12) << (-2.5*log10(V))-(-2.5*log10(KKK));

//colorfile <<"  "<< setw(12) << -2.5*log10(j2mass);

//colorfile <<"  "<< setw(12) << -2.5*log10(h2mass);

//colorfile <<"  "<< setw(12) << -2.5*log10(k2mass);

/// nou

if (savemass==1)
{
colorfile <<"  "<< setw(12) << mmax;
colorfile <<"  "<< setw(12) << m2;
colorfile <<"  "<< setw(12) << m3;
}


if (savemass2==1)
{
colorfile <<"  "<< setw(12) << mmax99;
colorfile <<"  "<< setw(12) << m299;
colorfile <<"  "<< setw(12) << m399;
}


if (savemass2==1)
{
colorfile.precision(2);
colorfile <<"  "<< setw(12) << mass;
}



//colorfile <<"  "<< setw(12) << mmax2;
//colorfile <<"  "<< setw(12) << mmax3;

///---nou


colorfile << '\n'; 


//cout << mmaxcluster<<'\n';


if (VERBOSE==0)
{
  cout <<setw(3) << a+1 <<"/"<<(int)(NOFILESOUT/ss) <<"  ("<<setw(3)<<a+1<<"/"<<NOFILESOUT<<") UBVRIJHK ... log(age/yr)=";
  
  if (fileplot[9]!='0') {cout<<fileplot[9];} 
  if (fileplot[9]=='0') {cout<<" ";} 
  
  cout<<fileplot[10]<<"."<<fileplot[11]<<fileplot[12]<<" ";
}




cout << "... done !"<< '\n';

filein.close();

chdir("..");
chdir("..");


}
///// ss>1 ss 1
////////////////////////////////
////////////////////////////////




/////////////////////////////////////////////////////
/////////////////////////////////////////////////////
/////////// ss>=2 ss 2
if ((ss>=2) && (a>=(int)(NOFILESOUT/ss)) && (a<(int)(NOFILESOUT/ss*2)) )
{




chdir("data"); 


  fileindex >> fileplot;
  fileindex.ignore(500,'\n');





chdir(".."); 
///  indextrek -END
//////////////////////////////////

chdir("data");
chdir("iso.trek");



////////////////////////////////////////////////
///////////////////////////////// MAX,M2,M3



if (savemass2==1)
{


//chdir("data");

  


  ifstream data499;
  data499.open(fileplot);

  if (data499.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }



int NBIN99;
NBIN99=datalinescolumn(fileplot,1);
//cout <<NBIN99<<'\n';

//double sari299,m399,m299,mmax99,massread99;

int i99;

while (data499.peek()=='#') { data499.ignore(300,'\n');}

mmax99=0.;

for (i99=1;i99<=NBIN99;i99++)
{

//data499.ignore(300,'\n');

//}

data499 >> sari299;
data499 >> massread99;
data499.ignore(300,'\n');

//if (i=1) {mmax99=massread99;}

if (massread99>=mmax99) {mmax99=massread99;}

//if (i==NBIN99) {cout<<setw(6)<< mmax99 <<'\n';}


//data499 >> m299;
//data499.ignore(300,'\n');

//data499 >> mmax99;
//data499.ignore(300,'\n');

//cout << m399 <<'\n';
//cout << m299 <<'\n';
//cout << mmax99 <<'\n';
}

data499.close();

//////////////////////////////////////
// m299

  ifstream data4994;

  data4994.open(fileplot);

  if (data4994.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }


while (data4994.peek()=='#') { data4994.ignore(300,'\n');}

m299=0.;

for (i99=1;i99<=NBIN99;i99++)
{

//data499.ignore(300,'\n');

//}

data4994 >> sari299;
data4994 >> massread99;
data4994.ignore(300,'\n');

//if (i=1) {mmax99=massread99;}

if ((massread99>=m299) && (massread99<mmax99) ) {m299=massread99;}

//if (i==NBIN99) {cout<<setw(6)<< m299 <<'\n';}


//data499 >> m299;
//data499.ignore(300,'\n');

//data499 >> mmax99;
//data499.ignore(300,'\n');

//cout << m399 <<'\n';
//cout << m299 <<'\n';
//cout << mmax99 <<'\n';
}

data4994.close();


//////////////////////++++++++++++++++++++++


//////////////////////////////////////
// m399

  ifstream data49944;

  data49944.open(fileplot);

  if (data49944.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }


while (data49944.peek()=='#') { data49944.ignore(300,'\n');}

m399=0.;

for (i99=1;i99<=NBIN99;i99++)
{

//data499.ignore(300,'\n');

//}

data49944 >> sari299;
data49944 >> massread99;
data49944.ignore(300,'\n');

//if (i=1) {mmax99=massread99;}

if ((massread99>=m399) && (massread99<m299) ) {m399=massread99;}

//if (i==NBIN99) {cout<<setw(6)<< m399 <<'\n';}


//data499 >> m299;
//data499.ignore(300,'\n');

//data499 >> mmax99;
//data499.ignore(300,'\n');

//cout << m399 <<'\n';
//cout << m299 <<'\n';
//cout << mmax99 <<'\n';
}

data49944.close();


//////////////////////++++++++++++++++++++++





//////////////////

//chdir("..");

/////////////////// nou mmax99cluster

} /// savemass2





///////////////////////////////// MAX,M2,M3
///////////////////////////////////////////////


  int NOPLOTLINES,NOPLOTCOLUMNS;

  NOPLOTLINES=datalinescolumn(fileplot,1);
 
//cout << NOPLOTLINES <<'\n';

  NOPLOTCOLUMNS=alldatacolumns(fileplot);
 
//cout << NOPLOTCOLUMNS <<'\n';


  ifstream filein;
  filein.open(fileplot);

 
 if (filein.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (filein.peek()=='#') { filein.ignore(3000,'\n');}



if (VERBOSE==1)
{
  cout << "Reading file "<< fileplot <<" ...";
}






double nonsens;
double readit, readit1, readit2, readit3, readit4, readit5, readit6, readit7;

double readit8, readit9, readit10;

double V=0.;
double B=0.;
double U=0.; 
double R=0.;
double III=0.;
double JJJ=0.;
double HHH=0.;
double KKK=0.;

//double j2mass=0.0;
//double h2mass=0.0;
//double k2mass=0.0;

//// nou
double minimax;
double mactmax;
double age;
double age00;////NOU
//// ---- nou

//  while (1)
//{

for (n=0;n<(NOPLOTLINES);n++)
       {

       {



       filein >> age00;
       if (n==0) {age=age00;}
   
       filein >> minimax;
       filein >> mactmax;
//       filein >> nonsens;
       filein >> nonsens;  //
       filein >> nonsens;  //
 
 
 filein >> readit; 
 filein >> readit3; 
 filein >> readit1; 
 filein >> readit2; 
 filein >> readit4; 
/* filein >> readit5; 
 filein >> readit6; 
 filein >> readit7;  */

// filein >> readit8; 
// filein >> readit9; 
// filein >> readit10; 
       
// if ((readit<16.) && (readit3<15.)  && (readit1<13.) && (readit<12.) && (readit4<11.)  && (readit5<10.) && (readit6<9.) && (readit7<9.) )
{
{U=U+pow(10.,(-(readit-A1-apparent)/2.5));}
{B=B+pow(10.,(-(readit3-A2-apparent)/2.5));}
{V=V+pow(10.,(-(readit1-A3-apparent)/2.5));}
{R=R+pow(10.,(-(readit2-A4-apparent)/2.5));}
{III=III+pow(10.,(-(readit4-A5-apparent)/2.5));}
/*
{JJJ=JJJ+pow(10.,(-(readit5-A_J-apparent)/2.5));}       
{HHH=HHH+pow(10.,(-(readit6-A_H-apparent)/2.5));}
{KKK=KKK+pow(10.,(-(readit7-A_K-apparent)/2.5));} */

//{j2mass=j2mass+pow(10.,(-(readit8-A_J-apparent)/2.5));}       
//{h2mass=h2mass+pow(10.,(-(readit9-A_H-apparent)/2.5));}
//{k2mass=k2mass+pow(10.,(-(readit10-A_K-apparent)/2.5));}


} 

       filein.ignore(300,'\n');



       }


        if(filein.eof()) break;
	}

//cout << minimax <<'\n';

if(filein.eof()) break;
//}

colorfile2.setf(ios::fixed,ios::floatfield);



colorfile2.precision(2);

colorfile2 << setw(6);


//if (fileplot[9]!='0') {colorfile2 << fileplot[9];}

//colorfile2<<fileplot[10]<<"."<<fileplot[11]<<fileplot[12];


colorfile2 << age ;//

colorfile2.precision(8);

colorfile2 <<"  "<< setw(12) << -2.5*log10(U);

colorfile2 <<"  "<< setw(12) << -2.5*log10(B);

colorfile2 <<"  "<< setw(12) << -2.5*log10(V);

colorfile2 <<"  "<< setw(12) << -2.5*log10(R);

colorfile2 <<"  "<< setw(12) << -2.5*log10(III);
/*
colorfile2 <<"  "<< setw(12) << -2.5*log10(JJJ);

colorfile2 <<"  "<< setw(12) << -2.5*log10(HHH);

colorfile2 <<"  "<< setw(12) << -2.5*log10(KKK);

colorfile2 <<"  "<< setw(12) << (-2.5*log10(U))-(-2.5*log10(B));

colorfile2 <<"  "<< setw(12) << (-2.5*log10(B))-(-2.5*log10(V));

colorfile2 <<"  "<< setw(12) << (-2.5*log10(V))-(-2.5*log10(KKK));

//colorfile2 <<"  "<< setw(12) << -2.5*log10(j2mass);

//colorfile2 <<"  "<< setw(12) << -2.5*log10(h2mass);

//colorfile2 <<"  "<< setw(12) << -2.5*log10(k2mass); */

/// nou

if (savemass==1)
{
colorfile2 <<"  "<< setw(12) << mmax;
colorfile2 <<"  "<< setw(12) << m2;
colorfile2 <<"  "<< setw(12) << m3;
}


if (savemass2==1)
{
colorfile2 <<"  "<< setw(12) << mmax99;
colorfile2 <<"  "<< setw(12) << m299;
colorfile2 <<"  "<< setw(12) << m399;
}


if (savemass2==1)
{
colorfile2.precision(2);
colorfile2 <<"  "<< setw(12) << mass;
}



//colorfile2 <<"  "<< setw(12) << mmax2;
//colorfile2 <<"  "<< setw(12) << mmax3;

///---nou


colorfile2 << '\n'; 


//cout << mmaxcluster<<'\n';


if (VERBOSE==0)
{
  cout <<setw(3) << a+1-(int)(NOFILESOUT/ss) <<"/"<<(int)(NOFILESOUT/ss) <<"  ("<<setw(3)<<a+1<<"/"<<NOFILESOUT<<") VISTA ZYJHKs ... log(age/yr)=";
  
  if (fileplot[9]!='0') {cout<<fileplot[9];} 
  if (fileplot[9]=='0') {cout<<" ";} 
  
  cout<<fileplot[10]<<"."<<fileplot[11]<<fileplot[12]<<" ";
}




cout << "... done !"<< '\n';

filein.close();

chdir("..");
chdir("..");


}
///// ss>=2 ss 2
////////////////////////////////
///////////////////////////////




/////////////////////////////////////////////////////
/////////////////////////////////////////////////////
/////////// ss>=3 ss 3
if ((ss>=3) && (a>=(int)(NOFILESOUT/ss*2)) && (a<(int)(NOFILESOUT/ss*3)) )
{


chdir("data"); 


  fileindex >> fileplot;
  fileindex.ignore(500,'\n');





chdir(".."); 
///  indextrek -END
//////////////////////////////////

chdir("data");
chdir("iso.trek");



////////////////////////////////////////////////
///////////////////////////////// MAX,M2,M3



if (savemass2==1)
{


//chdir("data");

  


  ifstream data499;
  data499.open(fileplot);

  if (data499.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }



int NBIN99;
NBIN99=datalinescolumn(fileplot,1);
//cout <<NBIN99<<'\n';

//double sari299,m399,m299,mmax99,massread99;

int i99;

while (data499.peek()=='#') { data499.ignore(300,'\n');}

mmax99=0.;

for (i99=1;i99<=NBIN99;i99++)
{

//data499.ignore(300,'\n');

//}

data499 >> sari299;
data499 >> massread99;
data499.ignore(300,'\n');

//if (i=1) {mmax99=massread99;}

if (massread99>=mmax99) {mmax99=massread99;}

//if (i==NBIN99) {cout<<setw(6)<< mmax99 <<'\n';}


//data499 >> m299;
//data499.ignore(300,'\n');

//data499 >> mmax99;
//data499.ignore(300,'\n');

//cout << m399 <<'\n';
//cout << m299 <<'\n';
//cout << mmax99 <<'\n';
}

data499.close();

//////////////////////////////////////
// m299

  ifstream data4994;

  data4994.open(fileplot);

  if (data4994.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }


while (data4994.peek()=='#') { data4994.ignore(300,'\n');}

m299=0.;

for (i99=1;i99<=NBIN99;i99++)
{

//data499.ignore(300,'\n');

//}

data4994 >> sari299;
data4994 >> massread99;
data4994.ignore(300,'\n');

//if (i=1) {mmax99=massread99;}

if ((massread99>=m299) && (massread99<mmax99) ) {m299=massread99;}

//if (i==NBIN99) {cout<<setw(6)<< m299 <<'\n';}


//data499 >> m299;
//data499.ignore(300,'\n');

//data499 >> mmax99;
//data499.ignore(300,'\n');

//cout << m399 <<'\n';
//cout << m299 <<'\n';
//cout << mmax99 <<'\n';
}

data4994.close();


//////////////////////++++++++++++++++++++++


//////////////////////////////////////
// m399

  ifstream data49944;

  data49944.open(fileplot);

  if (data49944.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }


while (data49944.peek()=='#') { data49944.ignore(300,'\n');}

m399=0.;

for (i99=1;i99<=NBIN99;i99++)
{

//data499.ignore(300,'\n');

//}

data49944 >> sari299;
data49944 >> massread99;
data49944.ignore(300,'\n');

//if (i=1) {mmax99=massread99;}

if ((massread99>=m399) && (massread99<m299) ) {m399=massread99;}

//if (i==NBIN99) {cout<<setw(6)<< m399 <<'\n';}


//data499 >> m299;
//data499.ignore(300,'\n');

//data499 >> mmax99;
//data499.ignore(300,'\n');

//cout << m399 <<'\n';
//cout << m299 <<'\n';
//cout << mmax99 <<'\n';
}

data49944.close();


//////////////////////++++++++++++++++++++++





//////////////////

//chdir("..");

/////////////////// nou mmax99cluster

} /// savemass2





///////////////////////////////// MAX,M2,M3
///////////////////////////////////////////////


  int NOPLOTLINES,NOPLOTCOLUMNS;

  NOPLOTLINES=datalinescolumn(fileplot,1);
 
//cout << NOPLOTLINES <<'\n';

  NOPLOTCOLUMNS=alldatacolumns(fileplot);
 
//cout << NOPLOTCOLUMNS <<'\n';


  ifstream filein;
  filein.open(fileplot);

 
 if (filein.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (filein.peek()=='#') { filein.ignore(3000,'\n');}



if (VERBOSE==1)
{
  cout << "Reading file "<< fileplot <<" ...";
}






double nonsens;
double readit, readit1, readit2, readit3, readit4, readit5, readit6, readit7;

double readit8, readit9, readit10;

double V=0.;
double B=0.;
double U=0.; 
double R=0.;
double III=0.;
double JJJ=0.;
double HHH=0.;
double KKK=0.;

//double j2mass=0.0;
//double h2mass=0.0;
//double k2mass=0.0;

//// nou
double minimax;
double mactmax;
double age;
double age00;////NOU
//// ---- nou

//  while (1)
//{

for (n=0;n<(NOPLOTLINES);n++)
       {

       {



       filein >> age00;
       if (n==0) {age=age00;}
   

       filein >> minimax;
       filein >> mactmax;
//       filein >> nonsens;
       filein >> nonsens;  //
       filein >> nonsens;  //
 
 
 filein >> readit; 
 filein >> readit3; 
// filein >> readit1; 
/* filein >> readit2; 
 filein >> readit4; 
 filein >> readit5; 
 filein >> readit6; 
 filein >> readit7;  */

// filein >> readit8; 
// filein >> readit9; 
// filein >> readit10; 
       
// if ((readit<16.) && (readit3<15.)  && (readit1<13.) && (readit<12.) && (readit4<11.)  && (readit5<10.) && (readit6<9.) && (readit7<9.) )
{
{U=U+pow(10.,(-(readit-A_U-apparent)/2.5));}
{B=B+pow(10.,(-(readit3-A_B-apparent)/2.5));}
//{V=V+pow(10.,(-(readit1-A_V-apparent)/2.5));}
/*{R=R+pow(10.,(-(readit2-A_R-apparent)/2.5));}
{III=III+pow(10.,(-(readit4-A_I-apparent)/2.5));}
{JJJ=JJJ+pow(10.,(-(readit5-A_J-apparent)/2.5));}       
{HHH=HHH+pow(10.,(-(readit6-A_H-apparent)/2.5));}
{KKK=KKK+pow(10.,(-(readit7-A_K-apparent)/2.5));} */

//{j2mass=j2mass+pow(10.,(-(readit8-A_J-apparent)/2.5));}       
//{h2mass=h2mass+pow(10.,(-(readit9-A_H-apparent)/2.5));}
//{k2mass=k2mass+pow(10.,(-(readit10-A_K-apparent)/2.5));}


} 

       filein.ignore(300,'\n');



       }


        if(filein.eof()) break;
	}

//cout << minimax <<'\n';

if(filein.eof()) break;
//}

/*
colorfile3.setf(ios::fixed,ios::floatfield);


colorfile3.precision(2);

colorfile3 << setw(6);


//if (fileplot[9]!='0') {colorfile3 << fileplot[9];}

//colorfile3<<fileplot[10]<<"."<<fileplot[11]<<fileplot[12];


colorfile3 << age ;//

colorfile3.precision(8);

colorfile3 <<"  "<< setw(12) << -2.5*log10(U);

colorfile3 <<"  "<< setw(12) << -2.5*log10(B);
*/

//colorfile3 <<"  "<< setw(12) << -2.5*log10(V);

/*colorfile3 <<"  "<< setw(12) << -2.5*log10(R);

colorfile3 <<"  "<< setw(12) << -2.5*log10(III);

colorfile3 <<"  "<< setw(12) << -2.5*log10(JJJ);

colorfile3 <<"  "<< setw(12) << -2.5*log10(HHH);

colorfile3 <<"  "<< setw(12) << -2.5*log10(KKK);

colorfile3 <<"  "<< setw(12) << (-2.5*log10(U))-(-2.5*log10(B));

colorfile3 <<"  "<< setw(12) << (-2.5*log10(B))-(-2.5*log10(V));

colorfile3 <<"  "<< setw(12) << (-2.5*log10(V))-(-2.5*log10(KKK));

//colorfile3 <<"  "<< setw(12) << -2.5*log10(j2mass);

//colorfile3 <<"  "<< setw(12) << -2.5*log10(h2mass);

//colorfile3 <<"  "<< setw(12) << -2.5*log10(k2mass); */

/// nou

/*
if (savemass==1)
{
colorfile3 <<"  "<< setw(12) << mmax;
colorfile3 <<"  "<< setw(12) << m2;
colorfile3 <<"  "<< setw(12) << m3;
}


if (savemass2==1)
{
colorfile3 <<"  "<< setw(12) << mmax99;
colorfile3 <<"  "<< setw(12) << m299;
colorfile3 <<"  "<< setw(12) << m399;
}


if (savemass2==1)
{
colorfile3.precision(2);
colorfile3 <<"  "<< setw(12) << mass;
}

*/

//colorfile3 <<"  "<< setw(12) << mmax2;
//colorfile3 <<"  "<< setw(12) << mmax3;

///---nou


/////colorfile3 << '\n'; 


//cout << mmaxcluster<<'\n';


if (VERBOSE==0)
{
  cout <<setw(3) << a+1-(int)(NOFILESOUT/ss*2) <<"/"<<(int)(NOFILESOUT/ss) <<"  ("<<setw(3)<<a+1<<"/"<<NOFILESOUT<<") GALEX FUV,NUV ... log(age/yr)=";
  
  if (fileplot[9]!='0') {cout<<fileplot[9];} 
  if (fileplot[9]=='0') {cout<<" ";} 
  
  cout<<fileplot[10]<<"."<<fileplot[11]<<fileplot[12]<<" ";
}




cout << "... done !"<< '\n';

filein.close();

chdir("..");
chdir("..");


}
///// ss>=3 ss 3
////////////////////////////////
///////////////////////////////








} ///  "a" loop





colorfile.close();
colorfile0.close();
colorfile2.close();
//colorfile3.close();

if (ss>1)
{

chdir("data");
chdir("colors");

ifstream file1;
file1.open("intcolors.01");
ifstream file2;
file2.open("intcolors.02");
//ifstream file3;
//file3.open("intcolors.03");

while (file1.peek()=='#') { file1.ignore(300,'\n');}
while (file2.peek()=='#') { file2.ignore(300,'\n');}
//while (file3.peek()=='#') { file3.ignore(300,'\n');}


  ofstream outfile99("intcolors");

  if (outfile99.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;

  }

chdir("..");
chdir("..");

outfile99.setf(ios::fixed,ios::floatfield);

//}



//////// HEADER here

if (COLORINI==1)
{
  outfile99 <<"##  "<< '\n';
  outfile99 <<"##  MASSCLEAN 2.013 Brave Bunny"<< '\n';
  outfile99 <<"##  B.Popescu and M.M.Hanson, 2007-2013 "<< '\n';
  outfile99 <<"##  http://www.physics.uc.edu/~popescu/massclean/"<< '\n';

  outfile99 <<"##  "<< '\n';

  outfile99 <<"##  Popescu & Hanson 2009, AJ, 138, 1724"<< '\n';
  outfile99 <<"##  Popescu & Hanson 2010, ApJL, 713, L21"<< '\n';
  outfile99 <<"##  Popescu & Hanson 2010, ApJ, 724, 296"<< '\n';
  outfile99 <<"##  Popescu, Hanson & Elmegreen 2012, ApJ, 751, 122"<< '\n';
  outfile99 <<"##  Popescu & Hanson 2014, ApJ, 780, 27"<< '\n';

  outfile99 <<"##  "<< '\n';

outfile99 << "##  log(age)        U             B             V             R             I             J             H             K            U-B          B-V            V-K               Z             Y             J             H             Ks       "<<'\n';
outfile99 << "##     1            2             3             4             5             6             7             8             9             10           11             12               13            14            15            16            17      "<<'\n';
}

int abc;

double agefinal;
double readcolors,tzeapa;
double readcolors3,readcolors33;

cout.setf(ios::fixed,ios::floatfield);

for (abc=0;abc<(int)(NOFILESOUT/ss);abc++)

{

file1 >> agefinal;
outfile99.precision(2);
outfile99 << setw(5)<<agefinal<<"  ";

file1 >> readcolors;
outfile99.precision(8);
outfile99 << setw(12)<<readcolors<<"  ";

file1 >> readcolors;
outfile99.precision(8);
outfile99 << setw(12)<<readcolors<<"  ";

file1 >> readcolors;
outfile99.precision(8);
outfile99 << setw(12)<<readcolors<<"  ";

file1 >> readcolors;
outfile99.precision(8);
outfile99 << setw(12)<<readcolors<<"  ";

file1 >> readcolors;
outfile99.precision(8);
outfile99 << setw(12)<<readcolors<<"  ";

file1 >> readcolors;
outfile99.precision(8);
outfile99 << setw(12)<<readcolors<<"  ";

file1 >> readcolors;
outfile99.precision(8);
outfile99 << setw(12)<<readcolors<<"  ";

file1 >> readcolors;
outfile99.precision(8);
outfile99 << setw(12)<<readcolors<<"  ";

file1 >> readcolors;
outfile99.precision(8);
outfile99 << setw(12)<<readcolors<<"  ";

file1 >> readcolors;
outfile99.precision(8);
outfile99 << setw(12)<<readcolors<<"  ";

file1 >> readcolors;
outfile99.precision(8);
outfile99 << setw(12)<<readcolors<<"  ";



file2 >> tzeapa;


file2 >> readcolors;
outfile99.precision(8);
outfile99 << setw(12)<<readcolors<<"  ";


file2 >> readcolors;
outfile99.precision(8);
outfile99 << setw(12)<<readcolors<<"  ";


file2 >> readcolors;
outfile99.precision(8);
outfile99 << setw(12)<<readcolors<<"  ";


file2 >> readcolors;
outfile99.precision(8);
outfile99 << setw(12)<<readcolors<<"  ";


file2 >> readcolors;
outfile99.precision(8);
outfile99 << setw(12)<<readcolors<<"  ";



/*
file3 >> tzeapa;

file3 >> readcolors;
outfile99.precision(8);
outfile99 << setw(12)<<readcolors<<"  ";


file3 >> readcolors;
outfile99.precision(8);
outfile99 << setw(12)<<readcolors<<"  ";
*/





outfile99<<'\n';
file1.ignore(500,'\n');
file2.ignore(500,'\n');
//file3.ignore(500,'\n');

cout<<setw((int)(log10(NOFILESOUT/ss)+1));
cout << abc+1<<"/"<<(int)(NOFILESOUT/ss)<<" U-K,VISTA";
if (ss==3) {cout<<",GALEX";}

cout.precision(2);
cout<<" ... log(age/yr)="<<setw(5)<<agefinal;
  



cout << " ... done !"<< '\n';


}

}//ss>1


cout <<'\n';

cout <<"... all done !" <<"\n";

cout <<'\n';

return 0;
}

