////////////////////////////////////////////////////////////////////////////////
//
//
//   Author       : Bogdan Popescu
//   Organization : University of Cincinnati
//   Program      : gowidecmdvista
//   Version      : 2.013
//   Date         : Dec 10, 2013
//   Tested       : g++ 4.6.3 x64 (Ubuntu 12.04 LTS x64)
//                        
//                     
//                  
//
////////////////////////////////////////////////////////////////////////////////
//
//    MASSCLEAN (MASSive CLuster Evolution and ANalysis Package)
//    Copyright (C) 2007-2013 BOGDAN POPESCU and MARGARET HANSON
//
//    gowidecmdvista.cc is part of MASSCLEAN.
//
//    MASSCLEAN is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation.
//
//    MASSCLEAN is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with MASSCLEAN; if not, write to the Free Software
//    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//    or go to : http://www.gnu.org/licenses/gpl.html
//
////////////////////////////////////////////////////////////////////////////////



#include <iostream>
#include <fstream>
#include <stdio.h>
#include <math.h>
#include <ctype.h> 
#include <iomanip> 
#include <stdlib.h> 


#define NOCOLUMNS 1

#define PI 3.14159265


using namespace std;



int alllines(char *name)
{
//////////////////////
////
//// 
////

  int NOLINES;

  char oneline[5000];
  NOLINES=0;

  ifstream data0;

  data0.open(name);

  if (data0.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (!data0.eof())
  {
     if (!isdigit(data0.peek()) || !isspace(data0.peek()))
	{
	    NOLINES=NOLINES+1;

            data0.getline(oneline,5000,'\n');

	    if(data0.eof()) break;
	}

     if (isdigit(data0.peek()) || isspace(data0.peek()))
       {
            NOLINES=NOLINES+1;

            data0.getline(oneline,5000,'\n');

            if(data0.eof()) break;
        }

   if(data0.eof()) break;
   }

  data0.close();

  return NOLINES;

}


int alldatalines(char *name, int NOLINES)
{
//////////////////////
////
//// 
////

  int i,k;

  int NODATALINES;

  double read_column;

  NODATALINES=0;

  ifstream data1;

  data1.open(name);

  if (data1.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

for (k=0;k<(NOLINES);k++)
 {
   if (isdigit(data1.peek()) || isspace(data1.peek()))
       {
       for (i=0;i<(NOCOLUMNS);i++)  
            {                      
            data1 >> read_column ;
           
            }
        NODATALINES=NODATALINES+1;

        if(data1.eof()) break;
        }

   if (!isdigit(data1.peek()) || !isspace(data1.peek()))
	  {data1.ignore(5000,'\n');data1.peek(); }

 if(data1.eof()) break;
 }

  data1.close();

return NODATALINES;

}


int alldatacolumns(char *name)
{
//////////////////////
////
//// 
////

  int NOCOL;

  double col;

  NOCOL=0;

  ifstream data3;

  data3.open(name);

  if (data3.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (data3.peek()=='#') {data3.ignore(5000,'\n'); }

  while (1)
  {
  data3 >> col ;

  NOCOL=NOCOL+1;

  if(data3.peek()=='\n') break;

  if(data3.eof()) break;
  }

  data3.close();

 return NOCOL;

}


int datalinescolumn(char *name, int i)

{
 if (i==1) return alldatalines(name,alllines(name));
 if (i==2) return alldatacolumns(name);
}



///////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
///////////
///////////  MAIN PROGRAM
///////////
//////////////////////////////////////////////////////////////////////////////////

int main()
{
  cout << "\n";


  cout <<"MASSCLEAN 2.013 (MASSive CLuster Evolution and ANalysis Package)"<<"\n";

  cout <<"Copyright (C) 2007-2013 BOGDAN POPESCU and MARGARET HANSON,"<<"\n";

  cout <<"under GNU General Public License. For details see 'COPYING'."<<"\n";

  cout <<"The program 'goWIDECMDVISTA' is part of MASSCLEAN 2.013 BB (Brave Bunny)."<<"\n";

  cout << "\n";
  cout <<"http://www.physics.uc.edu/~popescu/massclean/"<< '\n';

  cout << "\n";


  cout <<"Popescu & Hanson 2009, AJ, 138, 1724"<< '\n';
  cout <<"Popescu & Hanson 2010, ApJL, 713, L21"<< '\n';
  cout <<"Popescu & Hanson 2010, ApJ, 724, 296"<< '\n';
  cout <<"Popescu, Hanson & Elmegreen 2012, ApJ, 751, 122"<< '\n';
  cout <<"Popescu & Hanson 2014, ApJ, 780, 27"<< '\n';


  cout << "\n";
  cout << "\n";

  chdir("..");
  chdir("..");
  chdir("ini.files");

  double MASS;
  int VERBOSE;

  ifstream data0("cluster.ini");

  if (data0.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (data0.peek()=='#') { data0.ignore(300,'\n');}

  data0 >> VERBOSE; data0.ignore(300,'\n');
  data0 >> MASS; data0.ignore(300,'\n');
  data0.ignore(300,'\n');

  data0.close();

  chdir("..");
  chdir("utility");
  chdir("widecmd");



//double MASS=1000.;



double Wmax=0.30; //2.5, 5, 2, 0.5 0.25-->0.30
double Ymin=-14.;
double Ymax=12.; //12 , 10-->12
double Mminlim=0.15; //0.7, 1, 0.15 , 0.35-->8.60, 0.60


  /// prototypes
  int alllines(char*);
  int alldatalines(char*,int);
  int alldatacolumns(char*);
  int datalinescolumn(char*,int);


  srand((unsigned)time(0));

//outfile.setf(ios::fixed,ios::floatfield); 



  char nameinuse[18];
  char nameinuse2[23];


  ifstream fileinzero;
  fileinzero.open("vista.in");

  if (fileinzero.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }


/*
  ifstream fileinone;
  fileinone.open("vista.out");

  if (fileinone.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }
*/

/*
fileinone.width(24);
fileinone >> nameinuse2;
fileinone.ignore(30,'\n');
*/

fileinzero.width(19);
fileinzero >> nameinuse;
fileinzero.ignore(30,'\n');



//cout << nameinuse <<"  "<< nameinuse2 <<'\n';

char BLANK0[24];

BLANK0[0]='\0';


char BLANK1[24];

BLANK1[0]='\0';


strcat(BLANK0,nameinuse);
strcat(BLANK0,".wide");


cout << nameinuse <<"  "<< BLANK0  <<'\n';


  int NOSTARS,NOSTARS2;

//  chdir(".."); // utility
//  chdir(".."); // MAIN
//  chdir("data"); // data

/*
  chdir(".."); // utility
  chdir(".."); // MAIN
  chdir("data"); // data
  chdir("iso.trek"); // iso.trek

  cout<<NOSTARS<<" "<<NOSTARS2<<'\n';  

  NOSTARS2=datalinescolumn(nameinuse,1);

//  NOSTARS2=alllines(nameinuse);

cout << "Error ! "<<'\n';
 
  cout<<NOSTARS<<" "<<NOSTARS2<<'\n';  


  chdir(".."); // data
  chdir(".."); // MAIN
  chdir("utility"); // data
  chdir("widecmd"); // iso.trek


*/


  NOSTARS=datalinescolumn("mass-gauss.txt",1);

//  NOSTARS=alllines("mass-gauss.txt");

//cout << "Error1 ! "<<'\n';

  chdir(".."); // utility
  chdir(".."); // MAIN
  chdir("data"); // data
  chdir("iso.trek"); // iso.trek

//  cout<<NOSTARS<<" "<<NOSTARS2<<'\n';  

  NOSTARS2=datalinescolumn(nameinuse,1);

//  NOSTARS2=alllines(nameinuse);

//cout << "Error ! "<<'\n';
 
  cout<<NOSTARS<<" "<<NOSTARS2<<'\n';  

ifstream filein;
filein.open(nameinuse);
if (filein.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

while (filein.peek()=='#') { filein.ignore(300,'\n');}


  chdir(".."); // data
  chdir(".."); // MAIN
  chdir("utility"); // utility
  chdir("widecmd"); // widecmd



//  chdir(".."); // MAIN
//  chdir("utility"); // utility
//  chdir("widecmd"); // widecmd

/*
double age,Mini,Mact,logL,logT;
double J,H,Ks;
double gauss;
double mass;
*/

// ofstream outfile(nameinuse2);

 ofstream outfile(BLANK0);

  if (outfile.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;

  }

outfile.setf(ios::fixed,ios::floatfield);

int i, k;



//for (i=0;i<NOSTARS;i++)
for (i=0;i<NOSTARS2;i++)
{


double age,Mini,Mact,logL,logT;
double Z,Y,J,H,Ks;
double gauss, gauss2, gauss3, gauss4, gauss5;
double mass;


filein>> age;
filein>> Mini;

filein>> Mact;
filein>> logL;
filein>> logT;

filein>> Z;
filein>> Y;
filein>> J;
filein>> H;
filein>> Ks;


filein.ignore(300,'\n');




//cout<<Mini<<'\n';


ifstream filein2;
filein2.open("mass-gauss.txt");
if (filein2.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

while (filein2.peek()=='#') { filein2.ignore(300,'\n');}



//while (1)
for (k=0;k<NOSTARS;k++)
{
filein2>> mass;
filein2>> gauss;
filein2>> gauss2;
filein2>> gauss3;
filein2>> gauss4;
filein2>> gauss5;

filein2.ignore(300,'\n');

if (mass==Mini) 
{

//cout<<mass<<'\n';
//outfile<< setw(16)<< mass<<"  ";
break;
}


}

if (Mini>=Mminlim)
{

outfile.precision(2);

outfile << setw(6)<< age<<"   ";

outfile.precision(10);

outfile<<setw(16) << Mini<<"   "<<setw(16)<<Mact;

//outfile<<setw(16) << logL <<"   ";

//outfile<<setw(16) << logT <<"   ";


outfile<<setw(16) << Z + (Wmax+log10(log10(MASS)))*(Z-Ymin)/(Ymax-Ymin)*gauss <<"   ";

outfile<<setw(16) << Y + (Wmax+log10(log10(MASS)))*(Y-Ymin)/(Ymax-Ymin)*gauss2 <<"   ";


outfile<<setw(16) << J + (Wmax+log10(log10(MASS)))*(J-Ymin)/(Ymax-Ymin)*gauss3 <<"   ";

outfile<<setw(16) << H + (Wmax+log10(log10(MASS)))*(H-Ymin)/(Ymax-Ymin)*gauss4 <<"   ";

outfile<<setw(16) << Ks + (Wmax+log10(log10(MASS)))*(Ks-Ymin)/(Ymax-Ymin)*gauss5 <<"   ";



outfile<<'\n';
} //Mminlim


} // i loop

cout <<"... all done !" <<'\n';

cout <<'\n';



 return 0;

}

